/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#ifndef INTRODUCERLIST_H
#define INTRODUCERLIST_H

#include <iostream>
#include <string>
#include <list>

#include "errorintroducer.hpp"
#include "wordlist.hpp"
#include "settings.hpp"
#include "errorwriter.hpp"
#include "inputreader.hpp"

class IntroducerList {
public:
     IntroducerList(Wordlist &, Settings &, ErrorWriter &, InputReader &);
     void readAllFiles();
     std::list<std::pair<ErrorIntroducer,double> >& getList();
protected:
     std::list<std::pair<ErrorIntroducer,double> > introducerlist;
     Wordlist &wordlist;
     Settings &settings;
     ErrorWriter &errorwriter;
     InputReader &inputreader;
};

#endif
